diff --git a/contrib/btree_gist/btree_time.c b/contrib/btree_gist/btree_time.c
index cbbe05d..efb53e7 100644
--- a/contrib/btree_gist/btree_time.c
+++ b/contrib/btree_gist/btree_time.c
@@ -29,12 +29,25 @@ Datum		gbt_timetz_consistent(PG_FUNCTION_ARGS);
 Datum		gbt_time_penalty(PG_FUNCTION_ARGS);
 Datum		gbt_time_same(PG_FUNCTION_ARGS);
 
+/* workaround for bug in utils/date.h about Datum and TimeADT conversation */
+static float8 timeadt1, timeadt2;
+
+static float8*
+makeTimeADTPointer( float8* t, TimeADT s ) {
+	*t = s;
+	return t;
+}
+
+#define VoidGetDatum1(x)	PointerGetDatum(  makeTimeADTPointer(&timeadt1, *(TimeADT*)(x)) )
+#define VoidGetDatum2(x)	PointerGetDatum(  makeTimeADTPointer(&timeadt2, *(TimeADT*)(x)) )
+#define P_TimeADTGetDatum1(x)	PointerGetDatum(  makeTimeADTPointer(&timeadt1, (x)) )
+#define P_TimeADTGetDatum2(x)	PointerGetDatum(  makeTimeADTPointer(&timeadt2, (x)) )
 
 static bool
 gbt_timegt(const void *a, const void *b)
 {
 	return DatumGetBool(
-						DirectFunctionCall2(time_gt, TimeADTGetDatum(*((TimeADT *) a)), TimeADTGetDatum(*((TimeADT *) b)))
+						DirectFunctionCall2(time_gt, VoidGetDatum1(a), VoidGetDatum2(b))
 		);
 }
 
@@ -42,7 +55,7 @@ static bool
 gbt_timege(const void *a, const void *b)
 {
 	return DatumGetBool(
-						DirectFunctionCall2(time_ge, TimeADTGetDatum(*((TimeADT *) a)), TimeADTGetDatum(*((TimeADT *) b)))
+						DirectFunctionCall2(time_ge, VoidGetDatum1(a), VoidGetDatum2(b))
 		);
 }
 
@@ -50,7 +63,7 @@ static bool
 gbt_timeeq(const void *a, const void *b)
 {
 	return DatumGetBool(
-						DirectFunctionCall2(time_eq, TimeADTGetDatum(*((TimeADT *) a)), TimeADTGetDatum(*((TimeADT *) b)))
+						DirectFunctionCall2(time_eq, VoidGetDatum1(a), VoidGetDatum2(b))
 		);
 }
 
@@ -58,7 +71,7 @@ static bool
 gbt_timele(const void *a, const void *b)
 {
 	return DatumGetBool(
-						DirectFunctionCall2(time_le, TimeADTGetDatum(*((TimeADT *) a)), TimeADTGetDatum(*((TimeADT *) b)))
+						DirectFunctionCall2(time_le, VoidGetDatum1(a), VoidGetDatum2(b))
 		);
 }
 
@@ -66,7 +79,7 @@ static bool
 gbt_timelt(const void *a, const void *b)
 {
 	return DatumGetBool(
-						DirectFunctionCall2(time_lt, TimeADTGetDatum(*((TimeADT *) a)), TimeADTGetDatum(*((TimeADT *) b)))
+						DirectFunctionCall2(time_lt, VoidGetDatum1(a), VoidGetDatum2(b))
 		);
 }
 
@@ -116,17 +129,23 @@ Datum
 gbt_timetz_compress(PG_FUNCTION_ARGS)
 {
 	GISTENTRY  *entry = (GISTENTRY *) PG_GETARG_POINTER(0);
-	GISTENTRY  *retval;
+	GISTENTRY  *retval = entry;
 
 	if (entry->leafkey)
 	{
 		timeKEY    *r = (timeKEY *) palloc(sizeof(timeKEY));
 		TimeTzADT  *tz = DatumGetTimeTzADTP(entry->key);
+		TimeADT		tmp;
 
 		retval = palloc(sizeof(GISTENTRY));
 
 		/* We are using the time + zone only to compress */
-		r->lower = r->upper = (tz->time + tz->zone);
+#ifdef HAVE_INT64_TIMESTAMP
+		tmp = tz->time + (tz->zone * INT64CONST(1000000));
+#else
+		tmp = (tz->time + tz->zone);
+#endif
+		r->lower = r->upper = tmp;
 		gistentryinit(*retval, PointerGetDatum(r),
 					  entry->rel, entry->page,
 					  entry->offset, sizeof(timeKEY), FALSE);
@@ -141,7 +160,6 @@ Datum
 gbt_time_consistent(PG_FUNCTION_ARGS)
 {
 	GISTENTRY  *entry = (GISTENTRY *) PG_GETARG_POINTER(0);
-	TimeADT		query = PG_GETARG_TIMEADT(1);
 	timeKEY    *kkk = (timeKEY *) DatumGetPointer(entry->key);
 	GBT_NUMKEY_R key;
 	StrategyNumber strategy = (StrategyNumber) PG_GETARG_UINT16(2);
@@ -151,7 +169,7 @@ gbt_time_consistent(PG_FUNCTION_ARGS)
 
 
 	PG_RETURN_BOOL(
-				   gbt_num_consistent(&key, (void *) &query, &strategy, GIST_LEAF(entry), &tinfo)
+				   gbt_num_consistent(&key, (void *) PG_GETARG_POINTER(1), &strategy, GIST_LEAF(entry), &tinfo)
 		);
 }
 
@@ -160,17 +178,25 @@ gbt_timetz_consistent(PG_FUNCTION_ARGS)
 {
 	GISTENTRY  *entry = (GISTENTRY *) PG_GETARG_POINTER(0);
 	TimeTzADT  *query = PG_GETARG_TIMETZADT_P(1);
-	TimeADT		qqq = query->time + query->zone;
+	StrategyNumber strategy = (StrategyNumber) PG_GETARG_UINT16(2);
+
 	timeKEY    *kkk = (timeKEY *) DatumGetPointer(entry->key);
+	TimeADT		qqq;
 	GBT_NUMKEY_R key;
-	StrategyNumber strategy = (StrategyNumber) PG_GETARG_UINT16(2);
+	bool res;
+
+#ifdef HAVE_INT64_TIMESTAMP
+	qqq = query->time + (query->zone * INT64CONST(1000000));
+#else
+	qqq = (query->time + query->zone);
+#endif
 
 	key.lower = (GBT_NUMKEY *) & kkk->lower;
 	key.upper = (GBT_NUMKEY *) & kkk->upper;
 
-	PG_RETURN_BOOL(
-				   gbt_num_consistent(&key, (void *) &qqq, &strategy, GIST_LEAF(entry), &tinfo)
-		);
+	res = gbt_num_consistent(&key, (void *) &qqq, &strategy, GIST_LEAF(entry), &tinfo);
+
+	PG_RETURN_BOOL( res );
 }
 
 
@@ -202,8 +228,8 @@ gbt_time_penalty(PG_FUNCTION_ARGS)
 
 	intr = DatumGetIntervalP(DirectFunctionCall2(
 												 time_mi_time,
-										TimeADTGetDatum(newentry->upper),
-									 TimeADTGetDatum(origentry->upper)));
+										P_TimeADTGetDatum1(newentry->upper),
+									 P_TimeADTGetDatum2(origentry->upper)));
 
 	/* see interval_larger */
 	res = Max(intr->time + intr->month * (30 * 86400), 0);
@@ -211,8 +237,8 @@ gbt_time_penalty(PG_FUNCTION_ARGS)
 
 	intr = DatumGetIntervalP(DirectFunctionCall2(
 												 time_mi_time,
-									   TimeADTGetDatum(origentry->lower),
-									  TimeADTGetDatum(newentry->lower)));
+									   P_TimeADTGetDatum1(origentry->lower),
+									  P_TimeADTGetDatum2(newentry->lower)));
 
 	/* see interval_larger */
 	res += Max(intr->time + intr->month * (30 * 86400), 0);
@@ -224,8 +250,8 @@ gbt_time_penalty(PG_FUNCTION_ARGS)
 	{
 		intr = DatumGetIntervalP(DirectFunctionCall2(
 													 time_mi_time,
-									   TimeADTGetDatum(origentry->upper),
-									 TimeADTGetDatum(origentry->lower)));
+									   P_TimeADTGetDatum1(origentry->upper),
+									 P_TimeADTGetDatum2(origentry->lower)));
 		*result += FLT_MIN;
 		*result += (float) (res / ((double) (res + intr->time + intr->month * (30 * 86400))));
 		*result *= (FLT_MAX / (((GISTENTRY *) PG_GETARG_POINTER(0))->rel->rd_att->natts + 1));
diff --git a/contrib/btree_gist/btree_ts.c b/contrib/btree_gist/btree_ts.c
index f9d801a..aaa0c2e 100644
--- a/contrib/btree_gist/btree_ts.c
+++ b/contrib/btree_gist/btree_ts.c
@@ -29,6 +29,8 @@ Datum		gbt_ts_penalty(PG_FUNCTION_ARGS);
 Datum		gbt_ts_same(PG_FUNCTION_ARGS);
 
 
+#define P_TimestampGetDatum(x)  PointerGetDatum( &(x) )
+
 static bool
 gbt_tsgt(const void *a, const void *b)
 {
@@ -231,8 +233,8 @@ gbt_ts_penalty(PG_FUNCTION_ARGS)
 
 	intr = DatumGetIntervalP(DirectFunctionCall2(
 												 timestamp_mi,
-									  TimestampGetDatum(newentry->upper),
-									  TimestampGetDatum(origentry->upper)
+									  P_TimestampGetDatum(newentry->upper),
+									  P_TimestampGetDatum(origentry->upper)
 												 ));
 
 	/* see interval_larger */
@@ -242,8 +244,8 @@ gbt_ts_penalty(PG_FUNCTION_ARGS)
 
 	intr = DatumGetIntervalP(DirectFunctionCall2(
 												 timestamp_mi,
-									 TimestampGetDatum(origentry->lower),
-									   TimestampGetDatum(newentry->lower)
+									 P_TimestampGetDatum(origentry->lower),
+									   P_TimestampGetDatum(newentry->lower)
 												 ));
 
 	/* see interval_larger */
@@ -256,8 +258,8 @@ gbt_ts_penalty(PG_FUNCTION_ARGS)
 	{
 		intr = DatumGetIntervalP(DirectFunctionCall2(
 													 timestamp_mi,
-									 TimestampGetDatum(origentry->upper),
-									  TimestampGetDatum(origentry->lower)
+									 P_TimestampGetDatum(origentry->upper),
+									  P_TimestampGetDatum(origentry->lower)
 													 ));
 		*result += FLT_MIN;
 		*result += (float) (res / ((double) (res + intr->time + intr->month * (30 * 86400))));
diff --git a/contrib/btree_gist/btree_utils_num.c b/contrib/btree_gist/btree_utils_num.c
index f524427..f37c001 100644
--- a/contrib/btree_gist/btree_utils_num.c
+++ b/contrib/btree_gist/btree_utils_num.c
@@ -13,7 +13,6 @@ gbt_num_compress(GISTENTRY *retval, GISTENTRY *entry, const gbtree_ninfo * tinfo
 		{
 			int16		i2;
 			int32		i4;
-			TimeADT		ts;
 			DateADT		dt;
 		}			v;
 
@@ -34,10 +33,6 @@ gbt_num_compress(GISTENTRY *retval, GISTENTRY *entry, const gbtree_ninfo * tinfo
 				v.i4 = DatumGetObjectId(entry->key);
 				leaf = &v.i4;
 				break;
-			case gbt_t_time:
-				v.ts = DatumGetTimeADT(entry->key);
-				leaf = &v.ts;
-				break;
 			case gbt_t_date:
 				v.dt = DatumGetDateADT(entry->key);
 				leaf = &v.dt;
diff --git a/contrib/chkpass/chkpass.c b/contrib/chkpass/chkpass.c
index 7541685..92cc24d 100644
--- a/contrib/chkpass/chkpass.c
+++ b/contrib/chkpass/chkpass.c
@@ -82,14 +82,10 @@ chkpass_in(PG_FUNCTION_ARGS)
 	}
 
 	if (verify_pass(str) != 0)
-	{
 		ereport(ERROR,
 				(errcode(ERRCODE_DATA_EXCEPTION),
 				 errmsg("password \"%s\" is weak", str)));
 
-		PG_RETURN_POINTER(NULL);
-	}
-
 	result = (chkpass *) palloc(sizeof(chkpass));
 
 	mysalt[0] = salt_chars[random() & 0x3f];
@@ -112,9 +108,6 @@ chkpass_out(PG_FUNCTION_ARGS)
 	chkpass    *password = (chkpass *) PG_GETARG_POINTER(0);
 	char	   *result;
 
-	if (password == NULL)
-		PG_RETURN_POINTER(NULL);
-
 	if ((result = (char *) palloc(16)) != NULL)
 	{
 		result[0] = ':';
@@ -134,10 +127,7 @@ Datum
 chkpass_rout(PG_FUNCTION_ARGS)
 {
 	chkpass    *password = (chkpass *) PG_GETARG_POINTER(0);
-	text	   *result = NULL;
-
-	if (password == NULL)
-		PG_RETURN_POINTER(NULL);
+	text	   *result;
 
 	if ((result = (text *) palloc(VARHDRSZ + 16)) != NULL)
 	{
@@ -162,9 +152,6 @@ chkpass_eq(PG_FUNCTION_ARGS)
 	char		str[10];
 	int			sz = 8;
 
-	if (!a1 || !a2)
-		PG_RETURN_BOOL(0);
-
 	if (a2->vl_len < 12)
 		sz = a2->vl_len - 4;
 	strncpy(str, a2->vl_dat, sz);
@@ -181,8 +168,6 @@ chkpass_ne(PG_FUNCTION_ARGS)
 	char		str[10];
 	int			sz = 8;
 
-	if (!a1 || !a2)
-		PG_RETURN_BOOL(0);
 	if (a2->vl_len < 12)
 		sz = a2->vl_len - 4;
 	strncpy(str, a2->vl_dat, sz);
diff --git a/contrib/chkpass/chkpass.sql.in b/contrib/chkpass/chkpass.sql.in
index 0a29481..d4bf912 100644
--- a/contrib/chkpass/chkpass.sql.in
+++ b/contrib/chkpass/chkpass.sql.in
@@ -19,12 +19,12 @@ SET search_path = public;
 CREATE FUNCTION chkpass_in(cstring)
 	RETURNS chkpass
 	AS 'MODULE_PATHNAME'
-	LANGUAGE 'c';
+	LANGUAGE C STRICT;
 
 CREATE FUNCTION chkpass_out(chkpass)
 	RETURNS cstring
 	AS 'MODULE_PATHNAME'
-	LANGUAGE 'c';
+	LANGUAGE C STRICT;
 
 CREATE TYPE chkpass (
 	internallength = 16,
@@ -36,7 +36,7 @@ CREATE TYPE chkpass (
 CREATE FUNCTION raw(chkpass)
 	RETURNS text
 	AS 'MODULE_PATHNAME', 'chkpass_rout'
-	LANGUAGE 'c';
+	LANGUAGE C STRICT;
 
 --
 --	The various boolean tests:
@@ -45,12 +45,12 @@ CREATE FUNCTION raw(chkpass)
 CREATE FUNCTION eq(chkpass, text)
 	RETURNS bool
 	AS 'MODULE_PATHNAME', 'chkpass_eq'
-	LANGUAGE 'c';
+	LANGUAGE C STRICT;
 
 CREATE FUNCTION ne(chkpass, text)
 	RETURNS bool
 	AS 'MODULE_PATHNAME', 'chkpass_ne'
-	LANGUAGE 'c';
+	LANGUAGE C STRICT;
 
 --
 --	Now the operators.  Note how some of the parameters to some
diff --git a/contrib/dbase/Makefile b/contrib/dbase/Makefile
index 17096d3..3b1c9ac 100644
--- a/contrib/dbase/Makefile
+++ b/contrib/dbase/Makefile
@@ -3,7 +3,7 @@
 PROGRAM = dbf2pg
 OBJS	= dbf.o dbf2pg.o endian.o
 PG_CPPFLAGS = -I$(libpq_srcdir)
-PG_LIBS = $(libpq)
+PG_LIBS = $(libpq_pgport)
 
 # Uncomment this to provide charset translation
 #PG_CPPFLAGS += -DHAVE_ICONV_H
diff --git a/contrib/findoidjoins/Makefile b/contrib/findoidjoins/Makefile
index cb0f4b5..f0fac2d 100644
--- a/contrib/findoidjoins/Makefile
+++ b/contrib/findoidjoins/Makefile
@@ -4,7 +4,7 @@ PROGRAM = findoidjoins
 OBJS	= findoidjoins.o
 
 PG_CPPFLAGS = -I$(libpq_srcdir)
-PG_LIBS = $(libpq)
+PG_LIBS = $(libpq_pgport)
 
 SCRIPTS = make_oidjoins_check
 DOCS = README.findoidjoins
diff --git a/contrib/fuzzystrmatch/dmetaphone.c b/contrib/fuzzystrmatch/dmetaphone.c
index 6db4223..86b4853 100644
--- a/contrib/fuzzystrmatch/dmetaphone.c
+++ b/contrib/fuzzystrmatch/dmetaphone.c
@@ -48,7 +48,7 @@
 
 
 /*
- * $Revision: 1.4 $
+ * $Revision$
  * $Id$
  */
 
diff --git a/contrib/fuzzystrmatch/fuzzystrmatch.sql.in b/contrib/fuzzystrmatch/fuzzystrmatch.sql.in
index 07e6dce..6adb804 100644
--- a/contrib/fuzzystrmatch/fuzzystrmatch.sql.in
+++ b/contrib/fuzzystrmatch/fuzzystrmatch.sql.in
@@ -17,7 +17,7 @@ LANGUAGE 'C' WITH (iscachable, isstrict);
 
 CREATE FUNCTION text_soundex(text) RETURNS text
 AS 'MODULE_PATHNAME', 'soundex'
-LANGUAGE 'C';
+LANGUAGE 'C' WITH (iscachable, isstrict);
 
 CREATE FUNCTION dmetaphone (text) RETURNS text 
 LANGUAGE C IMMUTABLE STRICT
diff --git a/contrib/intagg/int_aggregate.sql.in b/contrib/intagg/int_aggregate.sql.in
index 8a7d9b3..af31f22 100644
--- a/contrib/intagg/int_aggregate.sql.in
+++ b/contrib/intagg/int_aggregate.sql.in
@@ -1,32 +1,43 @@
 -- Adjust this setting to control where the objects get created.
 SET search_path = public;
 
+--
+-- The aggregate transition state (denoted INT4 in caps below) is really
+-- an array, ie, int4[].  We have to lie and pretend it is a pass-by-value
+-- datatype so that nodeAgg.c will not try to do memory management for it.
+--
+
 -- Internal function for the aggregate
 -- Is called for each item in an aggregation
-CREATE OR REPLACE FUNCTION int_agg_state (int4, int4)
-RETURNS int4
+CREATE OR REPLACE FUNCTION int_agg_state (INT4, int4)
+RETURNS INT4
 AS 'MODULE_PATHNAME','int_agg_state'
-LANGUAGE 'C' IMMUTABLE STRICT;
+LANGUAGE 'C' STRICT;
 
 -- Internal function for the aggregate
 -- Is called at the end of the aggregation, and returns an array.
-CREATE OR REPLACE FUNCTION int_agg_final_array (int4)
+CREATE OR REPLACE FUNCTION int_agg_final_array (INT4)
 RETURNS int4[]
 AS 'MODULE_PATHNAME','int_agg_final_array'
-LANGUAGE 'C' IMMUTABLE STRICT;
+LANGUAGE 'C' STRICT;
 
 -- The aggregate function itself
 -- uses the above functions to create an array of integers from an aggregation.
 CREATE AGGREGATE int_array_aggregate (
 	BASETYPE = int4,
 	SFUNC = int_agg_state,
-	STYPE = int4,
+	STYPE = INT4,
 	FINALFUNC = int_agg_final_array,
 	INITCOND = 0
 );
 
+-- The aggregate component functions are not designed to be called
+-- independently, so disable public access to them
+REVOKE ALL ON FUNCTION int_agg_state (INT4, int4) FROM PUBLIC;
+REVOKE ALL ON FUNCTION int_agg_final_array (INT4) FROM PUBLIC;
+
 -- The enumeration function
--- returns each element in a one dimentional integer array
+-- returns each element in a one dimensional integer array
 -- as a row.
 CREATE OR REPLACE FUNCTION int_array_enum(int4[])
 RETURNS setof integer
diff --git a/contrib/intarray/README.intarray b/contrib/intarray/README.intarray
index a1ffef1..f850dee 100644
--- a/contrib/intarray/README.intarray
+++ b/contrib/intarray/README.intarray
@@ -60,6 +60,13 @@ test=# select subarray('{1,2,3,2,1}'::int[],2,3);
  {2,3,2}
 (1 row)
 
+  int[] intset(int4) - casting int4 to int[]
+
+test=# select intset(1);
+ intset 
+--------
+ {1}
+(1 row)
 
 OPERATIONS:
 
diff --git a/contrib/isbn_issn/isbn_issn.sql.in b/contrib/isbn_issn/isbn_issn.sql.in
index f4a9303..6731346 100644
--- a/contrib/isbn_issn/isbn_issn.sql.in
+++ b/contrib/isbn_issn/isbn_issn.sql.in
@@ -14,12 +14,12 @@ SET search_path = public;
 CREATE FUNCTION issn_in(cstring)
 RETURNS issn
 AS 'MODULE_PATHNAME'
-LANGUAGE 'C';
+LANGUAGE C STRICT;
 
 CREATE FUNCTION issn_out(issn)
 RETURNS cstring
 AS 'MODULE_PATHNAME'
-LANGUAGE 'C';
+LANGUAGE C STRICT;
 
 CREATE TYPE issn (
 	INTERNALLENGTH = 16,
@@ -39,32 +39,32 @@ COMMENT ON TYPE issn
 CREATE FUNCTION issn_lt(issn, issn)
 RETURNS bool
 AS 'MODULE_PATHNAME'
-LANGUAGE 'C';
+LANGUAGE C STRICT;
 
 CREATE FUNCTION issn_le(issn, issn)
 RETURNS bool
 AS 'MODULE_PATHNAME'
-LANGUAGE 'C';
+LANGUAGE C STRICT;
 
 CREATE FUNCTION issn_eq(issn, issn)
 RETURNS bool
 AS 'MODULE_PATHNAME'
-LANGUAGE 'C';
+LANGUAGE C STRICT;
 
 CREATE FUNCTION issn_ge(issn, issn)
 RETURNS bool
 AS 'MODULE_PATHNAME'
-LANGUAGE 'C';
+LANGUAGE C STRICT;
 
 CREATE FUNCTION issn_gt(issn, issn)
 RETURNS bool
 AS 'MODULE_PATHNAME'
-LANGUAGE 'C';
+LANGUAGE C STRICT;
 
 CREATE FUNCTION issn_ne(issn, issn)
 RETURNS bool
 AS 'MODULE_PATHNAME'
-LANGUAGE 'C';
+LANGUAGE C STRICT;
 
 --
 --	Now the operators.  Note how some of the parameters to some
@@ -120,7 +120,7 @@ CREATE OPERATOR <> (
 CREATE FUNCTION issn_cmp(issn, issn)
 RETURNS integer
 AS '$libdir/isbn_issn'
-LANGUAGE c;
+LANGUAGE c STRICT;
 
 -- Create default operator class for 'issn'    --
 -- Needed to create index or primary key       --
@@ -147,12 +147,12 @@ AS
 CREATE FUNCTION isbn_in(cstring)
 RETURNS isbn
 AS 'MODULE_PATHNAME'
-LANGUAGE 'C';
+LANGUAGE C STRICT;
 
 CREATE FUNCTION isbn_out(isbn)
 RETURNS cstring
 AS 'MODULE_PATHNAME'
-LANGUAGE 'C';
+LANGUAGE C STRICT;
 
 CREATE TYPE isbn (
 	INTERNALLENGTH = 16,
@@ -171,32 +171,32 @@ COMMENT ON TYPE isbn IS 'International Standard Book Number';
 CREATE FUNCTION isbn_lt(isbn, isbn)
 RETURNS bool
 AS 'MODULE_PATHNAME'
-LANGUAGE 'C';
+LANGUAGE C STRICT;
 
 CREATE FUNCTION isbn_le(isbn, isbn)
 RETURNS bool
 AS 'MODULE_PATHNAME'
-LANGUAGE 'C';
+LANGUAGE C STRICT;
 
 CREATE FUNCTION isbn_eq(isbn, isbn)
 RETURNS bool
 AS 'MODULE_PATHNAME'
-LANGUAGE 'C';
+LANGUAGE C STRICT;
 
 CREATE FUNCTION isbn_ge(isbn, isbn)
 RETURNS bool
 AS 'MODULE_PATHNAME'
-LANGUAGE 'C';
+LANGUAGE C STRICT;
 
 CREATE FUNCTION isbn_gt(isbn, isbn)
 RETURNS bool
 AS 'MODULE_PATHNAME'
-LANGUAGE 'C';
+LANGUAGE C STRICT;
 
 CREATE FUNCTION isbn_ne(isbn, isbn)
 RETURNS bool
 AS 'MODULE_PATHNAME'
-LANGUAGE 'C';
+LANGUAGE C STRICT;
 
 --
 --	Now the operators.  Note how some of the parameters to some
@@ -253,7 +253,7 @@ CREATE OPERATOR <> (
 CREATE FUNCTION isbn_cmp(isbn, isbn)
 RETURNS integer
 AS '$libdir/isbn_issn'
-LANGUAGE c;
+LANGUAGE c STRICT;
 
 -- Create default operator class for 'isbn'    --
 -- Needed to create index or primary key       --
diff --git a/contrib/lo/lo.sql.in b/contrib/lo/lo.sql.in
index acb1d81..d3370c4 100644
--- a/contrib/lo/lo.sql.in
+++ b/contrib/lo/lo.sql.in
@@ -15,13 +15,13 @@ SET search_path = public;
 CREATE FUNCTION lo_in(cstring)
 RETURNS lo
 AS 'MODULE_PATHNAME'
-LANGUAGE 'C' IMMUTABLE;
+LANGUAGE C IMMUTABLE STRICT;
 
 -- used by the lo type, it returns the oid of the object
 CREATE FUNCTION lo_out(lo)
 RETURNS cstring
 AS 'MODULE_PATHNAME'
-LANGUAGE 'C' IMMUTABLE;
+LANGUAGE C IMMUTABLE STRICT;
 
 -- finally the type itself
 CREATE TYPE lo (
@@ -35,7 +35,7 @@ CREATE TYPE lo (
 CREATE FUNCTION lo_oid(lo)
 RETURNS oid
 AS 'MODULE_PATHNAME'
-LANGUAGE 'C' IMMUTABLE;
+LANGUAGE C IMMUTABLE STRICT;
 
 -- same function, named to allow it to be used as a type coercion, eg:
 --    CREATE TABLE a (image lo);
@@ -44,7 +44,7 @@ LANGUAGE 'C' IMMUTABLE;
 CREATE FUNCTION oid(lo)
 RETURNS oid
 AS 'MODULE_PATHNAME', 'lo_oid'
-LANGUAGE 'C' IMMUTABLE;
+LANGUAGE C IMMUTABLE STRICT;
 CREATE CAST (lo as oid) WITH FUNCTION oid(lo) AS IMPLICIT;
 
 -- this allows us to convert an oid to a managed lo object
@@ -52,11 +52,11 @@ CREATE CAST (lo as oid) WITH FUNCTION oid(lo) AS IMPLICIT;
 CREATE FUNCTION lo(oid)
 RETURNS lo
 AS 'MODULE_PATHNAME'
-LANGUAGE 'C' IMMUTABLE;
+LANGUAGE C IMMUTABLE STRICT;
 CREATE CAST (oid as lo) WITH FUNCTION lo(oid) AS IMPLICIT;
 
 -- This is used in triggers
 CREATE FUNCTION lo_manage()
 RETURNS trigger
 AS 'MODULE_PATHNAME'
-LANGUAGE 'C';
+LANGUAGE C;
diff --git a/contrib/miscutil/misc_utils.c b/contrib/miscutil/misc_utils.c
index cb0f4b8..855addb 100644
--- a/contrib/miscutil/misc_utils.c
+++ b/contrib/miscutil/misc_utils.c
@@ -96,7 +96,7 @@ active_listeners(text *relname)
 	{
 		d = heap_getattr(lTuple, Anum_pg_listener_pid, tdesc, &isnull);
 		pid = DatumGetInt32(d);
-		if ((pid == ourpid) || (kill(pid, SIGTSTP) == 0))
+		if ((pid == ourpid) || (kill(pid, 0) == 0))
 			count++;
 	}
 	heap_endscan(sRel);
diff --git a/contrib/miscutil/misc_utils.sql.in b/contrib/miscutil/misc_utils.sql.in
index 5f777a1..7c1b5bf 100644
--- a/contrib/miscutil/misc_utils.sql.in
+++ b/contrib/miscutil/misc_utils.sql.in
@@ -37,14 +37,14 @@ LANGUAGE 'SQL';
 CREATE OR REPLACE FUNCTION min(int4,int4)
 RETURNS int4
 AS 'MODULE_PATHNAME', 'int4min'
-LANGUAGE 'C';
+LANGUAGE 'C' STRICT;
 
 -- max(x,y)
 --
 CREATE OR REPLACE FUNCTION max(int4,int4)
 RETURNS int4
 AS 'MODULE_PATHNAME', 'int4max'
-LANGUAGE 'C';
+LANGUAGE 'C' STRICT;
 
 -- Return the number of active listeners on a relation
 --
diff --git a/contrib/mysql/my2pg.pl b/contrib/mysql/my2pg.pl
index 10a1885..9726895 100755
--- a/contrib/mysql/my2pg.pl
+++ b/contrib/mysql/my2pg.pl
@@ -46,7 +46,15 @@
 # of the changes now before the tree starts shifting under me ...
 
 #
-# $Log: my2pg.pl,v $
+# $Log$
+# Revision 1.13  2004-04-19 23:18:12  momjian
+# Update to my2pg version 1.28, add docs, update URL for newest version.
+#
+# Create diff of custom changes Tom made to the utility for CREATE
+# FUNCTION.
+#
+# This will make moving this utility out of CVS easier.
+#
 # Revision 1.12  2004/04/19 23:11:49  momjian
 # Update to my2pg 1.28, from:
 #
@@ -769,7 +777,7 @@ close(LIBTYPES);
 
 open(MAKE,">Makefile");
 print MAKE "#
-# My2Pg \$Revision: 1.13 $ \translated dump
+# My2Pg \$Revision$ \translated dump
 # Makefile
 #
 
diff --git a/contrib/oid2name/Makefile b/contrib/oid2name/Makefile
index 02d51de..152cf1c 100644
--- a/contrib/oid2name/Makefile
+++ b/contrib/oid2name/Makefile
@@ -4,7 +4,7 @@ PROGRAM = oid2name
 OBJS	= oid2name.o
 
 PG_CPPFLAGS = -I$(libpq_srcdir)
-PG_LIBS = $(libpq)
+PG_LIBS = $(libpq_pgport)
 
 DOCS = README.oid2name
 
diff --git a/contrib/pg_autovacuum/Makefile b/contrib/pg_autovacuum/Makefile
index 00b1b3f..c512d18 100644
--- a/contrib/pg_autovacuum/Makefile
+++ b/contrib/pg_autovacuum/Makefile
@@ -2,7 +2,7 @@ PROGRAM = pg_autovacuum
 OBJS	= pg_autovacuum.o dllist.o
 
 PG_CPPFLAGS = -I$(libpq_srcdir) -DFRONTEND
-PG_LIBS = $(libpq)
+PG_LIBS = $(libpq_pgport)
 
 DOCS = README.pg_autovacuum
 
diff --git a/contrib/pg_autovacuum/README.pg_autovacuum b/contrib/pg_autovacuum/README.pg_autovacuum
index 00da36d..64c5eb5 100644
--- a/contrib/pg_autovacuum/README.pg_autovacuum
+++ b/contrib/pg_autovacuum/README.pg_autovacuum
@@ -36,9 +36,9 @@ list.
 
 pg_autovacuum requires that the statistics system be enabled and
 reporting row level stats.  The overhead of the stats system has been
-shown to have a significant cost under certain workloads.  For
-instance, a tight loop of queries performing "select 1" was found to
-run nearly 30% slower when stats were enabled.  However, in practice,
+shown to be significant under certain workloads.  For instance, a
+tight loop of queries performing "select 1" was found to run nearly
+30% slower when row-level stats were enabled.  However, in practice,
 with more realistic workloads, the stats system overhead is usually
 nominal.
 
@@ -127,8 +127,11 @@ pg_autovacuum has the following optional arguments:
 -U username: Username pg_autovacuum will use to connect with, if not
    specified the current username is used.
 -P password: Password pg_autovacuum will use to connect with. *WARNING*
-   When installed as a Windows Service, this option will be stored in plain
-   text in the registry.
+   This option is insecure. When installed as a Windows Service, this
+   option will be stored in plain text in the registry. When used with
+   most Unix variants, other users will be able to see the argument to
+   the "-P" option via ps(1). The ~/.pgpass file can be used to
+   specify a password more securely.
 -H host: host name or IP to connect to.
 -p port: port used for connection.
 -h help: list of command line options.
@@ -165,7 +168,7 @@ The following arguments are used on Windows only:
 -N service user: Name of the Windows user account under which the service
    will run. Only used when installing as a Windows service.
    
--W service password: The password for the service account.Only used when 
+-W service password: The password for the service account. Only used when 
    installing as a Windows service.
 
 -R Uninstall pg_autovacuum as a service.
diff --git a/contrib/pg_dumplo/Makefile b/contrib/pg_dumplo/Makefile
index 8373a0b..682d9dc 100644
--- a/contrib/pg_dumplo/Makefile
+++ b/contrib/pg_dumplo/Makefile
@@ -4,7 +4,7 @@ PROGRAM = pg_dumplo
 OBJS	= main.o lo_export.o lo_import.o utils.o
 
 PG_CPPFLAGS = -I$(libpq_srcdir)
-PG_LIBS = $(libpq)
+PG_LIBS = $(libpq_pgport)
 
 DOCS = README.pg_dumplo
 
diff --git a/contrib/pgbench/Makefile b/contrib/pgbench/Makefile
index 827fd1b..1e0f639 100644
--- a/contrib/pgbench/Makefile
+++ b/contrib/pgbench/Makefile
@@ -4,7 +4,7 @@ PROGRAM = pgbench
 OBJS	= pgbench.o
 
 PG_CPPFLAGS = -I$(libpq_srcdir)
-PG_LIBS = $(libpq)
+PG_LIBS = $(libpq_pgport)
 
 DOCS = README.pgbench README.pgbench_jis
 
diff --git a/contrib/pgcrypto/blf.c b/contrib/pgcrypto/blf.c
index e6dde08..a1af747 100644
--- a/contrib/pgcrypto/blf.c
+++ b/contrib/pgcrypto/blf.c
@@ -1,4 +1,4 @@
-/*	$OpenBSD$	*/
+/*	$OpenBSD: blf.c,v 1.3 2000/06/17 23:36:22 provos Exp $	*/
 
 /*
  * Blowfish block cipher for OpenBSD
diff --git a/contrib/pgcrypto/blf.h b/contrib/pgcrypto/blf.h
index 7ee728e..81159b1 100644
--- a/contrib/pgcrypto/blf.h
+++ b/contrib/pgcrypto/blf.h
@@ -1,4 +1,4 @@
-/*	$OpenBSD$ */
+/*	$OpenBSD: blf.h,v 1.3 2001/05/15 02:40:35 deraadt Exp $ */
 
 /*
  * Blowfish - a fast block cipher designed by Bruce Schneier
diff --git a/contrib/pgcrypto/crypt-des.c b/contrib/pgcrypto/crypt-des.c
index 4cf4803..0edff29 100644
--- a/contrib/pgcrypto/crypt-des.c
+++ b/contrib/pgcrypto/crypt-des.c
@@ -36,7 +36,7 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- * $FreeBSD$
+ * $FreeBSD: src/secure/lib/libcrypt/crypt-des.c,v 1.12 1999/09/20 12:39:20 markm Exp $
  *
  * This is an original implementation of the DES and the crypt(3) interfaces
  * by David Burren <davidb@werj.com.au>.
diff --git a/contrib/pgcrypto/crypt-md5.c b/contrib/pgcrypto/crypt-md5.c
index 1f81579..a7e21bf 100644
--- a/contrib/pgcrypto/crypt-md5.c
+++ b/contrib/pgcrypto/crypt-md5.c
@@ -1,7 +1,7 @@
 /*
  * File imported from FreeBSD, original by Poul-Henning Kamp.
  *
- * $FreeBSD$
+ * $FreeBSD: src/lib/libcrypt/crypt-md5.c,v 1.5 1999/12/17 20:21:45 peter Exp $
  *
  */
 /* $PostgreSQL$ */
diff --git a/contrib/pgcrypto/md5.c b/contrib/pgcrypto/md5.c
index acb094e..43c99a2 100644
--- a/contrib/pgcrypto/md5.c
+++ b/contrib/pgcrypto/md5.c
@@ -1,5 +1,5 @@
 /*	$PostgreSQL$	*/
-/*	   $KAME$	   */
+/*	   $KAME: md5.c,v 1.3 2000/02/22 14:01:17 itojun Exp $	   */
 
 /*
  * Copyright (C) 1995, 1996, 1997, and 1998 WIDE Project.
diff --git a/contrib/pgcrypto/md5.h b/contrib/pgcrypto/md5.h
index 4817951..0d0cb34 100644
--- a/contrib/pgcrypto/md5.h
+++ b/contrib/pgcrypto/md5.h
@@ -1,5 +1,5 @@
 /*	$PostgreSQL$	*/
-/*	   $KAME$	   */
+/*	   $KAME: md5.h,v 1.3 2000/02/22 14:01:18 itojun Exp $	   */
 
 /*
  * Copyright (C) 1995, 1996, 1997, and 1998 WIDE Project.
diff --git a/contrib/pgcrypto/misc.c b/contrib/pgcrypto/misc.c
index 734ad9f..5c803c0 100644
--- a/contrib/pgcrypto/misc.c
+++ b/contrib/pgcrypto/misc.c
@@ -26,7 +26,7 @@
  * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
  * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
- * $FreeBSD$
+ * $FreeBSD: src/lib/libcrypt/misc.c,v 1.1 1999/09/20 12:45:49 markm Exp $
  *
  */
 
diff --git a/contrib/pgcrypto/rijndael.c b/contrib/pgcrypto/rijndael.c
index 72611a7..8b2b99f 100644
--- a/contrib/pgcrypto/rijndael.c
+++ b/contrib/pgcrypto/rijndael.c
@@ -1,4 +1,4 @@
-/*	$OpenBSD$ */
+/*	$OpenBSD: rijndael.c,v 1.6 2000/12/09 18:51:34 markus Exp $ */
 
 /* This is an independent implementation of the encryption algorithm:	*/
 /*																		*/
diff --git a/contrib/pgcrypto/rijndael.h b/contrib/pgcrypto/rijndael.h
index aab1f51..41c1a2a 100644
--- a/contrib/pgcrypto/rijndael.h
+++ b/contrib/pgcrypto/rijndael.h
@@ -1,4 +1,4 @@
-/*	$OpenBSD$ */
+/*	$OpenBSD: rijndael.h,v 1.3 2001/05/09 23:01:32 markus Exp $ */
 
 /* This is an independent implementation of the encryption algorithm:	*/
 /*																		*/
diff --git a/contrib/pgcrypto/sha1.c b/contrib/pgcrypto/sha1.c
index a3195be..8a30cce 100644
--- a/contrib/pgcrypto/sha1.c
+++ b/contrib/pgcrypto/sha1.c
@@ -1,5 +1,5 @@
 /*	$PostgreSQL$ */
-/*	   $KAME$    */
+/*	   $KAME: sha1.c,v 1.3 2000/02/22 14:01:18 itojun Exp $    */
 
 /*
  * Copyright (C) 1995, 1996, 1997, and 1998 WIDE Project.
diff --git a/contrib/pgcrypto/sha1.h b/contrib/pgcrypto/sha1.h
index 1a1d664..a08b294 100644
--- a/contrib/pgcrypto/sha1.h
+++ b/contrib/pgcrypto/sha1.h
@@ -1,5 +1,5 @@
 /*	$PostgreSQL$ */
-/*	   $KAME$    */
+/*	   $KAME: sha1.h,v 1.4 2000/02/22 14:01:18 itojun Exp $    */
 
 /*
  * Copyright (C) 1995, 1996, 1997, and 1998 WIDE Project.
diff --git a/contrib/reindexdb/reindexdb b/contrib/reindexdb/reindexdb
index 7db6a26..2b2aeb9 100644
--- a/contrib/reindexdb/reindexdb
+++ b/contrib/reindexdb/reindexdb
@@ -1,6 +1,6 @@
 #!/bin/sh
 # -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- #
-# Package : reindexdb                 Version : $Revision: 1.5 $
+# Package : reindexdb                 Version : $Revision$
 # Date    : 05/08/2002                Author  : Shaun Thomas
 # Req     : psql, sh, perl, sed         Type  : Utility
 #
diff --git a/contrib/tsearch2/gendict/sql.IN b/contrib/tsearch2/gendict/sql.IN
index ff0d842..044230b 100644
--- a/contrib/tsearch2/gendict/sql.IN
+++ b/contrib/tsearch2/gendict/sql.IN
@@ -1,7 +1,7 @@
 SET search_path = public;
 BEGIN;
 
-HASINIT create function dinit_CFG_MODNAME(text)
+HASINIT create function dinit_CFG_MODNAME(internal)
 HASINIT         returns internal
 HASINIT         as 'MODULE_PATHNAME'
 HASINIT         language 'C';
diff --git a/contrib/tsearch2/tsearch.sql.in b/contrib/tsearch2/tsearch.sql.in
index 35f96cd..b51b049 100644
--- a/contrib/tsearch2/tsearch.sql.in
+++ b/contrib/tsearch2/tsearch.sql.in
@@ -44,7 +44,7 @@ CREATE FUNCTION set_curdict(text)
 	with (isstrict);
 
 --built-in dictionaries
-CREATE FUNCTION dex_init(text)
+CREATE FUNCTION dex_init(internal)
 	returns internal
 	as 'MODULE_PATHNAME' 
 	language 'C';
@@ -57,13 +57,13 @@ CREATE FUNCTION dex_lexize(internal,internal,int4)
 
 insert into pg_ts_dict select 
 	'simple', 
-	'dex_init(text)',
+	'dex_init(internal)',
 	null,
 	'dex_lexize(internal,internal,int4)',
 	'Simple example of dictionary.'
 ;
 	 
-CREATE FUNCTION snb_en_init(text)
+CREATE FUNCTION snb_en_init(internal)
 	returns internal
 	as 'MODULE_PATHNAME' 
 	language 'C';
@@ -76,26 +76,26 @@ CREATE FUNCTION snb_lexize(internal,internal,int4)
 
 insert into pg_ts_dict select 
 	'en_stem', 
-	'snb_en_init(text)',
+	'snb_en_init(internal)',
 	'contrib/english.stop',
 	'snb_lexize(internal,internal,int4)',
 	'English Stemmer. Snowball.'
 ;
 
-CREATE FUNCTION snb_ru_init(text)
+CREATE FUNCTION snb_ru_init(internal)
 	returns internal
 	as 'MODULE_PATHNAME' 
 	language 'C';
 
 insert into pg_ts_dict select 
 	'ru_stem', 
-	'snb_ru_init(text)',
+	'snb_ru_init(internal)',
 	'contrib/russian.stop',
 	'snb_lexize(internal,internal,int4)',
 	'Russian Stemmer. Snowball.'
 ;
 	 
-CREATE FUNCTION spell_init(text)
+CREATE FUNCTION spell_init(internal)
 	returns internal
 	as 'MODULE_PATHNAME' 
 	language 'C';
@@ -108,13 +108,13 @@ CREATE FUNCTION spell_lexize(internal,internal,int4)
 
 insert into pg_ts_dict select 
 	'ispell_template', 
-	'spell_init(text)',
+	'spell_init(internal)',
 	null,
 	'spell_lexize(internal,internal,int4)',
 	'ISpell interface. Must have .dict and .aff files'
 ;
 
-CREATE FUNCTION syn_init(text)
+CREATE FUNCTION syn_init(internal)
 	returns internal
 	as 'MODULE_PATHNAME' 
 	language 'C';
@@ -127,7 +127,7 @@ CREATE FUNCTION syn_lexize(internal,internal,int4)
 
 insert into pg_ts_dict select 
 	'synonym', 
-	'syn_init(text)',
+	'syn_init(internal)',
 	null,
 	'syn_lexize(internal,internal,int4)',
 	'Example of synonym dictionary'
